﻿using Hotline.Share.Dtos.CallCenter;
using Hotline.Share.Dtos.Order;
using Hotline.Tools;
using MapsterMapper;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using XF.Domain.Dependency;

namespace Hotline.Application.StatisticalReport;
public class ExportApplication : IExportApplication, IScopeDependency
{
    private readonly IMapper _mapper;

    public ExportApplication(IMapper mapper)
    {
        _mapper = mapper;
    }

    public async Task<Stream> FittingAsync<T, D>( ExportExcelDto<D> dto, List<T> items,Action<List<T>>? action = null)
    {
        if (items != null && items.Count > 0)
        {
            action?.Invoke(items);
        }

        dynamic? dynamicClass = DynamicClassHelper.CreateDynamicClass(dto.ColumnInfos);

        var dtos = items
            .Select(stu => _mapper.Map(stu, typeof(BiCallDto), dynamicClass))
            .Cast<object>()
            .ToList();

        return ExcelHelper.CreateStream(dtos);
    }
}
