﻿using Hotline.Share.Requests;
using System.ComponentModel.DataAnnotations;

namespace Hotline.Share.Dtos.CallCenter;

public record BiQueryCallsDto : ReportPagedRequest
{
    /// <summary>
    /// 开始时间
    /// </summary>
    [Required(ErrorMessage = "开始时间不能为空")]
    public new DateTime StartTime
    {
        get { return base.StartTime ?? throw new InvalidOperationException("开始时间不能为空"); }
        set { base.StartTime = value; }
    }

    /// <summary>
    /// 结束时间
    /// </summary>
    [Required(ErrorMessage = "结束时间不能为空")]
    public new DateTime EndTime
    {
        get { return base.StartTime ?? throw new InvalidOperationException("结束时间不能为空"); }
        set { base.StartTime = value; }
    }

    /// <summary>
    /// 线路
    /// </summary>
    public string? Line { get; set; }

    /// <summary>
    /// 查询类型 1：呼入总量明细；2：接通总量明细
    /// </summary>
    public string? TypeCode { get; set; } = "1";
}

public class BiQueryHourCallDto
{

    public DateTime StartTime { get; set; }

    [Required(ErrorMessage = "结束时间不能为空")]
    public DateTime EndTime { get; set; }
    public string Source { get; set; }
}

public class BiQueryGateWayDto
{
    public DateTime StartTime { get; set; }

    public DateTime EndTime { get; set; }

    public string gateway { get; set; }
}

public class TotalDataList<T>
{
    public TotalDataList()
    {
        
    }
    public TotalDataList(List<T> list, T total)
    {
        List = list;
        Total = total;
    }

    public T Total { get; set; }
    public List<T> List { get; set; }
}